﻿;==================================================================================================
;AUTHOR   : https://www.xyplorer.com/xyfc/viewtopic.php?t=25763
;Function : XYplorer 3 custom queue menus
;Created  : 2023-02-28
;Modified : 2023-05-17
;Version  : v1.3.3QS
;==================================================================================================
#Requires AutoHotkey v2.0.2
#HotIf MouseIsOver("ahk_class ThunderRT6FormDC")


MouseIsOver(WinTitle) {
    MouseGetPos ,, &Win
	return WinExist(WinTitle " ahk_id " Win)
}


; Get our own HWND (we have no visible window)
G_OwnHWND := A_ScriptHwnd + 0


; Get messages back from XYplorer
OnMessage(0x4a, Receive_WM_COPYDATA)

xyPath  := "D:\XYplorer\XYplorer.exe"      ; XY path
if !FileExist(xyPath)
{
   TrayTip xyPath, "XYplorer path does not exist!"
   ;ExitApp
}

exHwnd  := ""
global selMenu:="", selPos:="", selItem:="", IDLast:="", menusState := 0






;==================================================================================================
; Dark theme
;==================================================================================================

; Dark mode (Required Windows 10 version)
uxtheme := DllCall("GetModuleHandle", "str", "uxtheme", "ptr")
SetPreferredAppMode := DllCall("GetProcAddress", "ptr", uxtheme, "ptr", 135, "ptr")
FlushMenuThemes := DllCall("GetProcAddress", "ptr", uxtheme, "ptr", 136, "ptr")
DllCall(SetPreferredAppMode, "int", 1) ; Dark
DllCall(FlushMenuThemes)

; Switch from dark to not dark
/*
DllCall(SetPreferredAppMode, "int", 0) ; NOT Dark
DllCall(FlushMenuThemes)
*/



;==================================================================================================
; Add menu items, the format is   Name|XY script|Icon file
;==================================================================================================

menuItems := '
    (
     1`t`A|echo "1"|.\Icons\1.ico
	 2|echo "2"
	 3|echo "3"
	 4|echo "4"
	 5|echo "5"
	)'






;==================================================================================================
; Create a popup menu
;==================================================================================================

; Create main menu
 MyMenu := Menu()
 ;MyMenu.Name := "Main menu"                                   ; Used to show which menu is selected

 menuItemsArray := strSplit(menuItems, "`n")
 for index, menuItem in menuItemsArray
 {
    itemsArray := strSplit(trim(menuItem), "|")
    for index2, itemApart in itemsArray
    {
	   switch index2
	   {
	      case "1":
              if itemApart != "-"                                             ; Add an item to the menu, or add a separator
	             MyMenu.Add itemApart, MenuHandler
			  else
			     MyMenu.Add

          case "3":
              if FileExist(itemApart)
                 MyMenu.SetIcon(itemsArray[1], itemApart)                     ; Add icon if icon file exists
	   }
    }
 }

 ;MyMenu.Default := "1"

; Global selected
MenuHandler(Item, ItemPos, MyMenu) {
    if WinExist("ahk_class #32768")                               ; Automatically close another menu
	   global IDLast := WinGetIDLast("ahk_class #32768")
    if WinExist("ahk_id " IDLast)
       WinClose

	;MsgBox "You selected " Item " (position " ItemPos " in " MyMenu.Name ")"
	;global selMenu:=MyMenu.Name, selPos:=ItemPos, selItem:=Item   ; Global varibles

    selItem := strSplit(trim(menuItemsArray[ItemPos]), "|")[2]
	global selItem   ; Global varible
}






;==================================================================================================
; Rock-click (Left-Mouse-Down + Right-Mouse-Click) run custom menu
;==================================================================================================

~LButton & RButton Up::      ; Left-Mouse-Down + Right-Mouse-Click
{
 ctrl := ""
 if WinActive("ahk_class ThunderRT6FormDC")                          ; If in the XY window
 {
    MouseGetPos(&fX, &fY, &id, &ctrl)

    switch ctrl                                                      ; Floating preview does not support send script, run script via XYplorer.exe
    {
       case "ThunderRT6PictureBoxDC3":
	       ctrl := "FP"
	   default:
	       ctrls := WinGetControls(id)
           if ctrls.length > 20
              ctrl := true
           else
              ctrl := "FP"
    }

    WinGetPos(&dX, &dY, &dW, &dH, "ahk_class ThunderRT6FormDC")

    If(fX > 300 && fX < dW-235 && fY > 100 && fY < dH-60) {          ; Hover area: 300 is the width of the tree and 235 is the width of the Catalog or Preview pane, 100 is the height above the column header and 60 is the height of the status bar
	   run ".\menu2.ahk " ctrl " " G_OwnHWND                         ; Display menu2 after the first menu displayed
	   run ".\menu3.ahk " ctrl " " G_OwnHWND                         ; Display menu3 after menu2 displayed
	   sleep 50                                                      ; Try to display menus synchronously
	   while menusState < 2 {
	      sleep 1
		  if A_Index = 100
		     break
	   }

	   Send_WM_COPYDATA2("Ready", "menu2.ahk ahk_class AutoHotkey")  ; Send message to display menu2
       ;xyHwnd := GetxyHwnd()                                         ; Send the script to XY (Display XY menu #1400)
	   ;Send_WM_COPYDATA(xyHwnd, '::#1400')
	   CoordMode("menu")
	   MyMenu.Show(800, 200)                                         ; Display first menu at
	   global menusState := 0

	   if WinExist("ahk_class #32768") {                             ; Automatically close another menu
	      sleep 200
	      try IDLast := WinGetIDLast("ahk_class #32768")
		  catch
		      return
          MouseGetPos , , &id
          if WinGetClass("ahk_id " id) == "#32768"
		     send "{LButton}"

          if(WinExist("ahk_class " IDLast) && WinGetProcessName(WinActivate("A")) == "XYplorer.exe")
	         WinClose "ahk_class " IDLast
	      else if(WinExist("ahk_id " IDLast) && WinExist("ahk_id " id) && WinGetClass("ahk_id " id) != "#32768")
	         WinClose "ahk_id " IDLast
	      else if(WinExist("ahk_id " IDLast) && id == IDLast)
	         WinClose "ahk_id " IDLast
	   }
	} else Send("{RButton}")
 }






;==================================================================================================
; Perform different actions
;==================================================================================================

 switch selItem
 {
    case "":                                                                             ; ExitApp if no menu item is selected
	    return
    default:                                                                             ; If a menu item is selected
        if ctrl != "FP" && xyHwnd := GetXYHWND() {                                       ; If xy is running and not in the Floating Preview
		   WinActivate("ahk_id " xyHwnd)                                                 ; Active XY window
           Send_WM_COPYDATA(xyHwnd, '::' selItem)                                        ; Send the script to XY
        } else {
           Run xyPath ' /feed=|::' selItem '|'                                           ; Run the script via XYplorer.exe
		   ;WinWaitActive WinExist("ahk_class ThunderRT6FormDC")                          ; Waiting to activate the window
		   ;sleep 3000
		   ;WinActivate("ahk_class ThunderRT6FormDC")
        }
 }

 global selMenu:="", selPos:="", selItem:=""
 return

}






;==================================================================================================
; XYplorer Send and Get functions
;==================================================================================================

XY_Get(bAll:=false, bSelection:=false)
{
    xyQueryScript := '::if (!' bAll ' && !' bSelection ') {$return = "<curpath>"`;} elseif (' bAll ') {$return = listpane(, , , "<crlf>")`;} elseif (' bSelection ') {$return = get("SelectedItemsPathNames", "<crlf>")`;} copydata ' G_OwnHWND ', "$return", 2`;'

    if xyHwnd := GetXYHWND()
       Send_WM_COPYDATA(xyHwnd, xyQueryScript)

    return dataReceived
}


GetXYHWND() {
	static xyClass := 'ahk_class ThunderRT6FormDC'

	if hwnd := WinActive(xyClass)
		return hwnd
	else if WinExist(xyClass)
		return WinGetList(xyClass)[1]
}


Send_WM_COPYDATA(xyHwnd, message) {
   if !(xyHwnd)
       return

   size := StrLen(message)

   COPYDATA := Buffer(A_PtrSize * 3)
   NumPut("Ptr", 4194305, COPYDATA, 0)
   NumPut("UInt", size * 2, COPYDATA, A_PtrSize)
   NumPut("Ptr", StrPtr(message), COPYDATA, A_PtrSize * 2)

   return DllCall("User32.dll\SendMessageW", "Ptr", xyHwnd, "UInt", 74, "Ptr", 0, "Ptr", COPYDATA, "Ptr")
}


Receive_WM_COPYDATA(wParam, lParam, *) {
	global dataReceived := StrGet(
		NumGet(lParam + 2 * A_PtrSize, 'Ptr'),   ; COPYDATASTRUCT.lpData, ptr to a str presumably
		NumGet(lParam + A_PtrSize, 'UInt') / 2   ; COPYDATASTRUCT.cbData, count bytes of lpData, /2 to get count chars in unicode str
	)
	switch dataReceived {
	   case 2:
	      global menusState := menusState+1
	   case 3:
	      global menusState := menusState+1
    }
}






;==================================================================================================
; Send message to display next menu
;==================================================================================================

Send_WM_COPYDATA2(StringToSend, TargetScriptTitle)
{
    CopyDataStruct := Buffer(3*A_PtrSize)  ; Set up the structure's memory area.
    SizeInBytes := (StrLen(StringToSend) + 1) * 2
    NumPut( "Ptr", SizeInBytes, "Ptr", StrPtr(StringToSend), CopyDataStruct, A_PtrSize)
    Prev_DetectHiddenWindows := A_DetectHiddenWindows
    Prev_TitleMatchMode := A_TitleMatchMode
    DetectHiddenWindows True
    SetTitleMatchMode 2
    TimeOutTime := 10  ; Optional. Milliseconds to wait for response from receiver.ahk. Default is 5000
    try RetValue := SendMessage(0x004A, 0, CopyDataStruct,, TargetScriptTitle,,,, TimeOutTime) ; 0x004A is WM_COPYDATA.
	catch
	    return
    DetectHiddenWindows Prev_DetectHiddenWindows  ; Restore original setting for the caller.
    SetTitleMatchMode Prev_TitleMatchMode         ; Same.
    return RetValue  ; Return SendMessage's reply back to our caller.
}